/**************************** MAIN-MENU *****************************/

void show_menu(void)
{
//menu, in case DCF sync without manual time&date set
    switch(displaymode) 
        {
        case (SHOW_TIME):
            displaymode = SET_ALARM;
            display_str(LANG_ALARM, FALSE);
            set_alarm();
            break;
        case (SET_ALARM):
            if (ctrl_struct.dcf_sync)
                //this allows us to leave out settings menu for date and time in case dcf is sync
                displaymode = SET_TIMER_SYNC;
            else
                displaymode = SET_TIMER_NOSYNC;
            display_str(LANG_TIMER, FALSE);
            set_countdown();
            break;
        case (SET_TIMER_NOSYNC):
            ctrl_struct.timeunknown = 0;
            displaymode = SET_DATE;
            display_str(LANG_DATE, FALSE);
            set_date();
            break;
        case (SET_DATE):
            ctrl_struct.timeunknown = 0;
            displaymode = SET_TIME;
            display_str(LANG_TIME, FALSE);
            set_time();
            break;
        case (SET_TIME):
            displaymode = SET_NIGHTMODE;
            display_str(LANG_NIGHTMODE, FALSE);
            set_nightmode();
            break;
        case (SET_TIMER_SYNC):
            displaymode = SET_NIGHTMODE;
            display_str(LANG_NIGHTMODE, FALSE);
            set_nightmode();
            break;
        case (SET_NIGHTMODE):
            displaymode = SET_D_MODE;
            display_str(LANG_D_MODE, FALSE);
            set_digit_values();
            break;
        case (SET_D_MODE):
            displaymode = SET_DAYSAVETIME;
            display_str(LANG_DST, FALSE);
            set_digit_values();
            break;
        case (SET_DAYSAVETIME):
            displaymode = SET_EFFECT;
            display_str(LANG_EFFECT, FALSE);
            set_digit_values();
            break;
        case (SET_EFFECT):
            displaymode = SET_BRIGHTNESS;
            display_str(LANG_CONT, FALSE);
            set_brightness();
            break;
        case (SET_BRIGHTNESS):
            displaymode = SET_VOLUME;
            display_str(LANG_VOL, FALSE);
            set_digit_values();
            break;
        case (SET_VOLUME):
            displaymode = SET_LIGHT;
            display_str(LANG_LIGHT, FALSE);
            set_digit_values();
            break;
        case (SET_LIGHT):
            displaymode = SET_OFFSET;
            display_str(LANG_OFFSET, FALSE);
            set_offset();
            break;
        default:
            displaymode = SHOW_TIME;
        }        
}

/**************************** SUB-MENUS *****************************/

void set_alarm(void) 
{
    uint8_t mode;
    uint8_t hour, min, sec, days;
    
    hour = min = sec = 0;
    mode = SHOW_MENU;

    hour = alarm_h;
    min = alarm_m;
    days = alarm_days;
    sec = 0;
  
    timeoutcounter = INACTIVITYTIMEOUT;
  
    while (1) 
        {
        if (just_pressed & 0x1) 
            return;
        if (just_pressed || pressed) 
            {
            timeoutcounter = INACTIVITYTIMEOUT;  
            // timeout w/no buttons pressed after 3 seconds?
            } 
        else if (!timeoutcounter) 
            {
            //timed out!
            displaymode = SHOW_TIME;     
            alarm_h = hour;
            alarm_m = min;
            alarm_days = days;
            return;
            }
        if (just_pressed & 0x2) 
            {
            just_pressed = 0;
            if (mode == SHOW_MENU) 
                {
		// ok now its selected
		mode = SET_HOUR;
		display_alarm(hour, min, days);
		display[1] |= 0x1;
		display[2] |= 0x1;	
                } 
            else if (mode == SET_HOUR) 
                {
		mode = SET_MIN;
		display_alarm(hour, min, days);
		display[4] |= 0x1;
		display[5] |= 0x1;
                } 
            else if (mode == SET_MIN) 
                {
		mode = SET_DAYS;
		display_alarm(hour, min, days);
		display[7] |= 0x1;
		display[8] |= 0x1;
                }
            else 
                {
	// done!
		alarm_h = hour;
		alarm_m = min;
                alarm_days = days;
		eeprom_write_byte((uint8_t *)EE_ALARM_HOUR, hour);    
		eeprom_write_byte((uint8_t *)EE_ALARM_MIN, min); 
                eeprom_write_byte((uint8_t *)EE_ALARM_DAYS, days); 
		displaymode = SHOW_TIME;
		return;
                }
            }
        if ((just_pressed & 0x4) || (pressed & 0x4)) 
            {
            just_pressed = 0;

            if (mode == SET_HOUR) 
                {
		hour = (hour+1) % 24;
		display_alarm(hour, min, days);
		display[1] |= 0x1;
		display[2] |= 0x1;
            }
            if (mode == SET_MIN) 
                {
		min = (min+1) % 60;
		display_alarm(hour, min, days);
		display[4] |= 0x1;
		display[5] |= 0x1;
                }
            if (mode == SET_DAYS) 
                {
		days = (days+1) % 3;
		display_alarm(hour, min, days);
		display[7] |= 0x1;
		display[8] |= 0x1;
                }

            if (pressed & 0x4)
		delayms(200);
            }
        }
}

void set_brightness(void) 
{
    uint8_t mode = SHOW_MENU;
    uint8_t brightness;

    timeoutcounter = INACTIVITYTIMEOUT;  
    brightness = ctrl_struct.brightness;

    while (1) 
        {
        if (just_pressed || pressed) 
            {
            timeoutcounter = INACTIVITYTIMEOUT;  
            // timeout w/no buttons pressed after 3 seconds?
            } 
        else if (!timeoutcounter) 
            {
            //timed out!
            displaymode = SHOW_TIME;     
            eeprom_write_byte((uint8_t *)EE_BRIGHT, brightness);
            return;
            }
        if (just_pressed & 0x1)  // mode change
            return;
        if (just_pressed & 0x2) 
            {
            just_pressed = 0;
            if (mode == SHOW_MENU) 
                {
		// start!
		mode = SET_BRITE;
		// display brightness
		display_str(LANG_BRIGHT, FALSE);
		display[6] = pgm_read_byte(numbertable_p + (brightness / 100)) | 0x1;
		display[7] = pgm_read_byte(numbertable_p + ((brightness % 100) / 10)) | 0x1;
		display[8] = pgm_read_byte(numbertable_p + (brightness % 10)) | 0x1;
                } 
            else 
                {	
		displaymode = SHOW_TIME;
		return;
                }
            }
        if ((just_pressed & 0x4) || (pressed & 0x4)) 
            {
            just_pressed = 0;
            if (mode == SET_BRITE) 
                {
		brightness += 10;
		if (brightness > 101)
	  		brightness = 10;
		display[6] = pgm_read_byte(numbertable_p + (brightness / 100)) | 0x1;
		display[7] = pgm_read_byte(numbertable_p + ((brightness % 100) / 10)) | 0x1;
		display[8] = pgm_read_byte(numbertable_p + (brightness % 10)) | 0x1;
		eeprom_write_byte((uint8_t *)EE_BRIGHT, brightness);
                ctrl_struct.brightness = brightness;
                setboost (ctrl_struct.brightness);
                }
            if (pressed & 0x4)
                delayms(200);
            }
        }
}

void set_countdown(void) 
{
    uint8_t mode = SHOW_MENU;

    timeoutcounter = INACTIVITYTIMEOUT;  

    while (1) 
        {
        if (just_pressed || pressed) 
            {
            timeoutcounter = INACTIVITYTIMEOUT;  
            // timeout w/no buttons pressed after 3 seconds?
            } 
        else if (!timeoutcounter) 
            {
        //timed out!
        displaymode = SHOW_TIME;     
        return;
            }
        if (just_pressed & 0x1)  // mode change
            return;
        if (just_pressed & 0x2) 
            {

            just_pressed = 0;
            if (mode == SHOW_MENU) 
                {
		// start!
		mode = SET_TIM;
		// new countdown;
		countdown = 0;
		ctrl_struct.countdown_is_set = FALSE;
		// countdown timer
		display_str(LANG_SET_TIMER, FALSE);
		display[6] = pgm_read_byte(numbertable_p + (countdown / 100)) | 0x1;
		display[7] = pgm_read_byte(numbertable_p + ((countdown % 100) / 10)) | 0x1;
		display[8] = pgm_read_byte(numbertable_p + (countdown % 10)) | 0x1;
                } 
            else 
                {
		if (countdown)
                    ctrl_struct.countdown_is_set = 1;	
		displaymode = SHOW_TIME;
		return;
                }
            }
        if ((just_pressed & 0x4) || (pressed & 0x4)) 
            {
            just_pressed = 0;
            if (mode == SET_TIM) 
                {
		countdown += 1;
		if (countdown > 240)
	  		countdown = 0;
		display[6] = pgm_read_byte(numbertable_p + (countdown / 100)) | 0x1;
		display[7] = pgm_read_byte(numbertable_p + ((countdown % 100) / 10)) | 0x1;
		display[8] = pgm_read_byte(numbertable_p + (countdown % 10)) | 0x1;	
                }
            if (pressed & 0x4)
                delayms(200);
            }
        }
}

void set_date(void) 
{
    uint8_t mode = SHOW_MENU;
    uint8_t day, month, year;
    
    day = time.d;
    month = time.mo;
    year = time.y;

    timeoutcounter = INACTIVITYTIMEOUT;  

    while (1) 
        {
        if (just_pressed || pressed) 
            timeoutcounter = INACTIVITYTIMEOUT;  
            // timeout w/no buttons pressed after 3 seconds?
        else if (!timeoutcounter) 
            {
            //timed out!
            displaymode = SHOW_TIME;
            return;
            }
        if (just_pressed & 0x1)  // mode change
            return;
        if (just_pressed & 0x2) 
            {
            just_pressed = 0;
            if (mode == SHOW_MENU) 
                {
		// start!
                mode = SET_DAY;
		display_date(day, month, year, DATE, FALSE);
		display[1] |= 0x1;
		display[2] |= 0x1;
                } 
            else if (mode == SET_DAY)
                {
                mode = SET_MONTH;
		display_date(day, month, year, DATE, FALSE);
		display[4] |= 0x1;
		display[5] |= 0x1;
                } 
            else if (mode == SET_MONTH) 
                {
		mode = SET_YEAR;
		display_date(day, month, year, DATE, FALSE);
		display[7] |= 0x1;
		display[8] |= 0x1;
                } 
            else 
                {
		displaymode = NONE;
		display_date(day, month, year, DATE, FALSE);
		delayms(1500);
		displaymode = SHOW_TIME;
		return;
                }
            }
        if ((just_pressed & 0x4) || (pressed & 0x4)) 
            {
            just_pressed = 0;
            if (mode == SET_MONTH) 
                {
		month++;
		if (month >= 13)
                    month = 1;
		display_date(day, month, year, DATE, FALSE);
                display[4] |= 0x1;
                display[5] |= 0x1;
		time.mo = month;
		eeprom_write_byte((uint8_t *)EE_MONTH, time.mo);
                }
            if (mode == SET_DAY) 
                {
		day++;
  		if (day > 31)
                    day = 1;

		display_date(day, month, year, DATE, FALSE);
                display[4] |= 0x1;
                display[5] |= 0x1;
		time.d = day;
		time.mo = month;
		eeprom_write_byte((uint8_t *)EE_DAY, time.d);
                }
            if (mode == SET_YEAR) 
                {
		year++;
		year %= 100;
		display_date(day, month, year, DATE, FALSE);
		display[7] |= 0x1;
		display[8] |= 0x1;
		time.d = day;
		time.mo = month;
		time.y = year;
		eeprom_write_byte((uint8_t *)EE_YEAR, time.y); 
                }
            if (pressed & 0x4)
                delayms(200);
            }
        }
} 

// This function can be used for every configuration item, which just flips between two values (eg on /off)
void set_digit_values()
{
    uint8_t mode = SHOW_MENU;

    timeoutcounter = INACTIVITYTIMEOUT;  
    effect_ctrl.effect = eeprom_read_byte((uint8_t *)EE_EFFECT);

    while (1) 
        {
        if (just_pressed || pressed) 
            {
            timeoutcounter = INACTIVITYTIMEOUT;  
            // timeout w/no buttons pressed after 3 seconds?
            } 
        else if (!timeoutcounter) 
            {
            //timed out!
            displaymode = SHOW_TIME;     
            return;
            }
        if (just_pressed & 0x1)  // mode change
            return;
        if (just_pressed & 0x2) 
            {
            just_pressed = 0;
            if (mode == SHOW_MENU) 
                {
		// start!
                switch(displaymode)
                    {
                    case (SET_DAYSAVETIME):
                        mode = SET_DST;
                        if (ctrl_struct.dst == TRUE) 
                            display_str(LANG_ON, FALSE);
                        else 
                            display_str(LANG_OFF, FALSE);
                        break;
                    case (SET_D_MODE):
                        mode = SET_DMO;
                        if (ctrl_struct.d_mode == TRUE) 
                            display_str(LANG_D_MODE_1, FALSE);
                        else 
                            display_str(LANG_D_MODE_2, FALSE);
                        break;
                    case (SET_EFFECT):
                        mode = SET_EFF;
                        if (effect_ctrl.effect == TRUE) 
                            display_str(LANG_ON, FALSE);
                        else 
                            display_str(LANG_OFF, FALSE);
                        break;
                    case (SET_LIGHT):
                        mode = SET_LIG;
                        if (effect_ctrl.light == TRUE) 
                            display_str(LANG_LIGHT_TEMP, FALSE);
                        else 
                            display_str(LANG_LIGHT_RGB, FALSE);
                        break;
                    case (SET_VOLUME):
                        mode = SET_VOL;
                        // display volume
                        if (ctrl_struct.volume) 
                            {
                            display_str(LANG_HIGH, FALSE);
                            display[5] |= 0x1;
                            display[6] |= 0x1;
                            display[7] |= 0x1;
                            display[8] |= 0x1;
                            } 
                        else 
                            {
                            display_str(LANG_LOW, FALSE);
                            display[8] |= 0x1;
                            }
                        break;
                    }
                } 
            else 
                {	
		displaymode = SHOW_TIME;
		return;
                }
            }
        if (just_pressed & 0x4) 
            {
            just_pressed = 0;
            switch(mode)
                {
                case (SET_DST):
                    ctrl_struct.dst = !ctrl_struct.dst;
                    if (ctrl_struct.dst == TRUE)
	  		display_str(LANG_ON, FALSE);
                    else
	  		display_str(LANG_OFF, FALSE);
                    eeprom_write_byte((uint8_t *)EE_DST, ctrl_struct.dst);
                    break;
                case (SET_DMO):
                    ctrl_struct.d_mode = !ctrl_struct.d_mode;
                    if (ctrl_struct.d_mode == TRUE)
	  		display_str(LANG_D_MODE_1, FALSE);
                    else
	  		display_str(LANG_D_MODE_2, FALSE);
                    eeprom_write_byte((uint8_t *)EE_D_MODE, ctrl_struct.d_mode);
                    break;
                case (SET_EFF):
                    effect_ctrl.effect = !effect_ctrl.effect;
                    if (effect_ctrl.effect == TRUE) 
                        display_str(LANG_ON, FALSE);
                    else 
                        display_str(LANG_OFF, FALSE);
                    eeprom_write_byte((uint8_t *)EE_EFFECT, effect_ctrl.effect);
                    break;
                case (SET_LIG):
                    effect_ctrl.light = !effect_ctrl.light;
                    if (effect_ctrl.light == TRUE) 
                        {
                        display_str(LANG_LIGHT_TEMP, FALSE);
                        recreate_pwm_sequence();
                        } 
                    else 
                        {
                        display_str(LANG_LIGHT_RGB, FALSE);
                        recreate_pwm_sequence();
                        }
                    eeprom_write_byte((uint8_t *)EE_LIGHT, effect_ctrl.light);
                    break;
                case (SET_VOL):
                    ctrl_struct.volume = !ctrl_struct.volume;
                    if (ctrl_struct.volume) 
                        {
                        display_str(LANG_HIGH, FALSE);
                        display[5] |= 0x1;
                        display[6] |= 0x1;
                        display[7] |= 0x1;
                        display[8] |= 0x1;
                        } 
                    else 
                        {
                        display_str(LANG_LOW, FALSE);
                        display[8] |= 0x1;
                        }
                    eeprom_write_byte((uint8_t *)EE_VOLUME, ctrl_struct.volume);
                    speaker_init();
                    beep(4000, 1);
                    break;
                }
            }
        }
}

void set_nightmode(void) 
{
    uint8_t mode;
    uint8_t hour_on, hour_off;
    
    mode = SHOW_MENU;

    hour_on = nightmode_on_hour;
    hour_off = nightmode_off_hour;

    timeoutcounter = INACTIVITYTIMEOUT;
  
    while (1) 
        {
        if (just_pressed & 0x1) 
            return;
        if (just_pressed || pressed) 
            {
            timeoutcounter = INACTIVITYTIMEOUT;  
            // timeout w/no buttons pressed after 3 seconds?
            } 
        else if (!timeoutcounter) 
            {
            //timed out!
            displaymode = SHOW_TIME;     
            nightmode_on_hour = hour_on;
            nightmode_off_hour = hour_off;   
            return;
            }
        if (just_pressed & 0x2) 
            {
            just_pressed = 0;
            if (mode == SHOW_MENU) 
                {
		// ok now its selected
		mode = SET_HOUR;
		display_nightmode(hour_on, hour_off);
		display[1] |= 0x1;
		display[2] |= 0x1;	
                } 
            else if (mode == SET_HOUR) 
                {
		mode = SET_MIN;
		display_nightmode(hour_on, hour_off);
		display[7] |= 0x1;
		display[8] |= 0x1;
                } 
            else 
                {
                // done!
                nightmode_on_hour = hour_on;
                nightmode_off_hour = hour_off;     
		eeprom_write_byte((uint8_t *)EE_NIGHTMODE_ON_HOUR, hour_on);    
		eeprom_write_byte((uint8_t *)EE_NIGHTMODE_OFF_HOUR, hour_off);
		displaymode = SHOW_TIME;
		return;
                }
            }
        if ((just_pressed & 0x4) || (pressed & 0x4)) 
            {
            just_pressed = 0;

            if (mode == SET_HOUR_ON) 
                {
		hour_on = (hour_on+1) % 24;
		display_nightmode(hour_on, hour_off);
		display[1] |= 0x1;
		display[2] |= 0x1;
            }
            if (mode == SET_HOUR_OFF) 
                {
		hour_off = (hour_off+1) % 24;
		display_nightmode(hour_on, hour_off);
		display[7] |= 0x1;
		display[8] |= 0x1;
                }

            if (pressed & 0x4)
		delayms(200);
            }
        }
}

void set_offset(void) 
{
    uint8_t mode = SHOW_MENU;

    timeoutcounter = INACTIVITYTIMEOUT;  

    while (1) 
        {
        if (just_pressed || pressed) 
            {
            timeoutcounter = INACTIVITYTIMEOUT;  
            // timeout w/no buttons pressed after 3 seconds?
            } 
        else if (!timeoutcounter) 
            {
        //timed out!
        eeprom_write_byte((uint8_t *)EE_OFFSET, tempoffset);
        displaymode = SHOW_TIME;     
        return;
            }
        if (just_pressed & 0x1)  // mode change
            return;
        if (just_pressed & 0x2) 
            {
            just_pressed = 0;
            if (mode == SHOW_MENU) 
                {
		// start!
		mode = SET_OFF;
                if (temperature_raw > 0)
                    {
                    // temperature offset
                    display_temperature(FALSE);
                    if (tempoffset == 30)
                        display[1] = 0;
                    else if (tempoffset > 30)
                        display[1] = pgm_read_byte(alphatable_p + 'p' - 'a');
                    else
                        display[1] = pgm_read_byte(alphatable_p + 'n' - 'a');
                    }
                else
                    display_str(LANG_OFFSET_OFF, FALSE);                    
                } 
            else 
                {
		displaymode = SHOW_TIME;
		return;
                }
            }
        if ((just_pressed & 0x4) || (pressed & 0x4)) 
            {
            just_pressed = 0;
            if (mode == SET_OFF) 
                {
                if (temperature_raw > 0)
                    {
                    tempoffset += 1;
                    if (tempoffset > 60)
	  		tempoffset = 0;
                    display_temperature(FALSE);
                    if (tempoffset == 30)
                        display[1] = 0;
                    else if (tempoffset > 30)
                        display[1] = pgm_read_byte(alphatable_p + 'p' - 'a');
                    else
                        display[1] = pgm_read_byte(alphatable_p + 'n' - 'a');
                    eeprom_write_byte((uint8_t *)EE_OFFSET, tempoffset);
                    }
                else
                    display_str(LANG_OFFSET_OFF, FALSE);
                }
            if (pressed & 0x4)
                delayms(200);
            }
        }
}

void set_time(void) 
{
    uint8_t mode;
    uint8_t hour, min, sec;
    
    hour = time.h;
    min = time.m;
    sec = time.s;
    mode = SHOW_MENU;

    timeoutcounter = INACTIVITYTIMEOUT;
  
    while (1) 
        {
        if (just_pressed & 0x1)  // mode change
            return;
        if (just_pressed || pressed) 
            {
            timeoutcounter = INACTIVITYTIMEOUT;  
            // timeout w/no buttons pressed after 3 seconds?
            } 
        else if (!timeoutcounter) 
            {
            //timed out!
            displaymode = SHOW_TIME;     
            return;
            }
        if (just_pressed & 0x2) 
            {
            just_pressed = 0;
            if (mode == SHOW_MENU) 
                {
		hour = time.h;
		min = time.m;
		sec = time.s;

		// ok now its selected
		mode = SET_HOUR;
		display_time(hour, min, sec, FALSE);
		display[1] |= 0x1;
		display[2] |= 0x1;	
                } 
            else if (mode == SET_HOUR) 
                {
		mode = SET_MIN;
		display_time(hour, min, sec, FALSE);
		display[4] |= 0x1;
		display[5] |= 0x1;
                } 
            else if (mode == SET_MIN) 
                {
		mode = SET_SEC;
		display_time(hour, min, sec, FALSE);
		display[7] |= 0x1;
		display[8] |= 0x1;
                } 
            else 
                {
                // done!
		time.h = hour;
		time.m = min;
		time.s = sec;
		if (effect_ctrl.light == FALSE) 
                    recreate_pwm_sequence();
		displaymode = SHOW_TIME;
		return;
                }
            }
        if ((just_pressed & 0x4) || (pressed & 0x4)) 
            {
            just_pressed = 0;
      
            if (mode == SET_HOUR) 
                {
		hour = (hour+1) % 24;
		display_time(hour, min, sec, FALSE);
		display[1] |= 0x1;
		display[2] |= 0x1;
		time.h = hour;
		eeprom_write_byte((uint8_t *)EE_HOUR, time.h);
		if (effect_ctrl.light == FALSE) 
			recreate_pwm_sequence();
                }
            if (mode == SET_MIN) 
                {
		min = (min+1) % 60;
		display_time(hour, min, sec, FALSE);
		display[4] |= 0x1;
		display[5] |= 0x1;
		time.m = min;
		eeprom_write_byte((uint8_t *)EE_MIN, time.m);
		if (effect_ctrl.light == FALSE) 
			recreate_pwm_sequence();
                }
            if ((mode == SET_SEC) ) 
                {
		sec = (sec+1) % 60;
		display_time(hour, min, sec, FALSE);
		display[7] |= 0x1;
		display[8] |= 0x1;
		time.s = sec;
		eeprom_write_byte((uint8_t *)EE_SEC, time.s);
		if (effect_ctrl.light == FALSE) 
			recreate_pwm_sequence();
                }
            if (pressed & 0x4)
		delayms(200);
            }
        }
}




